% LU Factorization Example
% Coded by NFR on 3.31.2019
% For midterm 2 prep
%
% LU decomposition is a method that can be used for SOME systems of linear eqns.
%
% Decompose the coeffeicient matrix into a lower and upper form like this:
%
% L = [# 0 0;    U = [# # #;
%      # # 0;         0 # #;
%      # # #];        0 0 #];
%
% Where [L]*[U] = [A]
%
% This can then be used to solve the problem simply! I will show you in a
% moment.  You can solve for L and U matrices by hand, but for now you can
% rely on matlab to do this.
%
% Here is the derivation for this process:
% Remember that a system of linear equations takes this form:
% [A]{x} = {b}  where {} denotes a vector
% [A] = [L][U], so
% [L][U]{x} = {b}
% Now assume [U]{x} = {d}
% We can first solve {d} from [L]{d} = {b} (straightforward due to zeros)
% Then we solve for {x} from [U]{x} = {d} using the {d} found previous
% 
% Example:
% Assume the following coefficient matrix and right hand vector
A = [8 5 1; 3 7 4; 2 3 9];
b = [24; 28; 20];
%
% Solve for L and U
[L,U] = lu(A);
%{
Answer is:
L =

    1.0000         0         0
    0.3750    1.0000         0
    0.2500    0.3415    1.0000


U =

    8.0000    5.0000    1.0000
         0    5.1250    3.6250
         0         0    7.5122
%}
% Solve {d} from [L]{d} = {b} 
% d1 = 24
% d2 = 28 - d1*0.375 = 19
% d3 = 20 - 0.25*d1 - 0.3415*d2 = 7.512
%
% Solve for {x} from [U]{x} = {d}
%
% x3  = d3/7.512 = 1;
% x2 = (19-3.625*x3)/5.125 = 3;
% x1 = (24-1*x3-5*x2)/8 = 1;
%
% Solution = [1; 3; 1];
%
% Verify using the '\' command
% 
x = A\b


